include "D24.grm"

redefine decl
        ...
    |   (setq [id] (lambda () [number])) [NL]
end redefine

redefine conn
        ...
    |   (setq [id] (lambda () ([op] (funcall [id]) (funcall [id])))) [NL]
end redefine

function main
    replace [program]
        Is [init]
        Ns [net]
    by
        Is [exi]
        Ns [exn]
end function

rule exi
    replace [decl]
        VAR [id] : VAL [number]
    by
        (setq VAR (lambda () VAL))
end rule

rule exn
    replace [conn]
        A [id] O [op] B [id] -> C [id]
    construct NO [op]
        O [r1] [r2] [r3]
    by
        (setq C (lambda () ( NO (funcall A) (funcall B))))
end rule

rule r1
    replace [op]
        AND
    by
        logand
end rule

rule r2
    replace [op]
        XOR
    by
        logxor
end rule

rule r3
    replace [op]
        OR
    by
        logior
end rule
