include "D24.grm"

redefine decl
        ...
    |   (declare-const [id] Bool) [NL]
end redefine

redefine conn
        ...
    |   ('assert (= [id] ([op] [id] [id]))) [NL]
end redefine

function main
    replace [program]
        Is [repeat decl]
        Ns [repeat conn]
    construct NIs [repeat decl]
        _ [buildd each Ns]
    construct IIs [init]
        Is [exi] [. NIs]
    by
        IIs
        Ns [exn]
end function

function buildd  Co [conn]
    replace [repeat decl]
        Old [repeat decl]
    deconstruct Co
        _ [id] _ [op] _ [id] -> C [id]
    construct New [decl]
        (declare-const C Bool)
    by
        Old [. New]
end function

rule exi
    replace [decl]
        VAR [id] : VAL [number]
    by
        (declare-const VAR Bool)
end rule

rule exn
    replace [conn]
        A [id] O [op] B [id] -> C [id]
    construct NO [op]
        O [ra] [rb] [rc]
    by
        ('assert (= C (NO A B)))
end rule

rule ra
    replace [op]
        AND
    by
        and
end rule

rule rb
    replace [op]
        XOR
    by
        xor
end rule

rule rc
    replace [op]
        OR
    by
        or
end rule
